Subject: [IPP] HP Inc. has reviewed the IPP System Service v1.0 and has comments

From: "Kennedy, Smith \(Wireless & Standards Architect\) via ipp" <[email-masked]>
Date: Thu, 12 Sep 2019 05:20:02 +0000

Hi there,

Thanks Mike and Ira for all your work! HP Inc. has the following feedback (sorry, a long list):

Abstract and global: "This document" --> "this specification" ?
Line 394: need a reference to 5100.18 after "Cloud Imaging Systems"?
Line 486-487: Does this need to mention identity or how ownership is validated?
Line 518: Funny link takes over the entire line
Line 550: Why is "abstract print service" in parentheses?
Line 560: Seems like this line ought to roll over to the next page...
Line 580: Would it be better to use "IPP Management Client" or something that makes it clear that it isn't just a typical Client?
Line 587: Can we use a different name to make it clear that the "type" of user isn't the same as in the other use cases?
Line 620: "...defines a root object type called a..." ?
Lines 630-631: I found "Protocol Endpoint" defined earlier in this spec, but it isn't used at all in RFC 8011 or RFC 3510. When I think of this, I think of there being a distinct "resource path". Shouldn't we mention "resource paths" here or in the definition of Protocol Endpoint, or is the reader assumed to understand that connection?
Lines 652-653: "...Printer Status attribute that contains an integer unique identifier for each Printer object within the IPP System object..." --> "...Printer Status attribute that specifies an integer identifier unique for each Printer object within the IPP System object" ?
Lines 652-658: This probably needs to be more clear. Even after searching for "printer-id" in the document and reading the System Status and Printer Status attribute definitions, I wasn't able to tell whether there could be multiple "printer-id" values for a given Printer Object at a given "printer-uri" / resource path, or how a Client would end up using a "printer-id". I found mention as an operation attribute to, for instance, the Allocate-Printer-Resources operation. Looking at that, I guess "system-uri" + "printer-id" is to be used to refer to a Printer similarly to how "printer-uri" + "job-id" is used to refer to a Job. Can "system-uri" + "printer-id" be used interchangeably?
Lines 664-665: Are there any owner attributes that are not immutable? Also: awkward wording : "Job Owners are immutable (i.e., Job Status attributes)"  -->  "attributes specifying Job Owner are immutable and therefore Job Status attributes" ?
Lines 667-670: Even though IPP Document operations and attributes are not going to be directly addressed in this specification, is there anything to say about "Document Owner" / Document ownership?
Lines 671: Section 4.6 "Resource Object" should be referenced in the sections discussing the Create-Resource, Allocate-Printer-Resources, Deallocate-Printer-Resources, etc. operations that use it, as well as the definition of the "resource-use-count" attribute. Or maybe 680 - 693 needs to be moved to section 7.9.16 resource-use-count (integer(0:MAX)) (line 3876)?
Line 699: 'The System SHOULD "age" out (i.e. delete)...'  --> 'The System SHOULD delete...'
Line 707: Is there a risk of malicious actors using IPP Resources as a place to squirrel away their own files by, for instance, putting a compressed binary within a PDF and pretending it is a bitmap or something?
Lines 721-722: Same general comment as above for Lines 664-665?
Line 741: What does the column header "SM/IPP Equivalent" mean?
Line 741: Shouldn't the note indicators that pertain specifically to IPP be listed in the "IPP Attribute Name" column? An example: [2] should be next to "system-current-time", not "CurrentTime". Or remove the note if the "Reference" is 5108.06...
Do we need section 5? Most who implement IPP System Service will consider most of section 5 a historical novelty but not get any value from it...
Line 949-950: Since the System Service operations MAY require Client authentication, a Client supporting IPP System Service MUST be prepared for Client authentication challenges in response to IPP System Service operation requests, in addition to that Clients MUST support HTTP Basic and HTTP Digest authentication.
Lines 984-985: Aren't these superfluous if the System challenges the Client for authentication?
Lines 1124-1131: Don't these attributes purposes need more details? For example: "If this operation attribute is supplied, then the System MUST return the attributes and values for its Printers that support the matching geo-location URI. Matching criteria are implementation defined."
Lines 1134-1135: "...then the System MUST return the attributes and values for the selected Printers..."  --> "...then the System MUST return the attributes and values for its Printers that support the matching service types..."
Lines 1199-1201: Get-Printer-Resources wants a "printer-uri". Could a "system-uri" + "printer-id" combo be provided instead?
Lines 1265-1270: The inverse of the last one - could "printer-uri" be used instead of "system-uri" + "printer-id"? Or I guess the use of one vs. the other indicates whether the operation is a System object operation vs. a Printer object operation.
Line 2862: "System Description Attributes are typically READ-WRITE" --> Shouldn't they always be READ-WRITE, by definition? A READ-ONLY attribute would be a System Status attribute, and I don't think we have any WRITE-ONLY attributes...
Line 2884: Are there no System level feature keywords defined in System Service?

Smith

/**
    Smith Kennedy
    HP Inc.
*/

_______________________________________________
ipp mailing list
[email-masked]
https://www.pwg.org/mailman/listinfo/ipp